#ifndef _BUFFER_HH_
#define _BUFFER_HH_

#include "flat.hh"
#include "list.hh"

#define DEFAULT_BUFFER_SIZE      4096     
#define MAX_BUFFER_LENGTH       32768
#define BUFFER_STATUS_FREE       0x01
#define BUFFER_STATUS_READ       0x02
#define BUFFER_STATUS_WAIT       0x05 

class Buffer : public FlatMemory
{
private:
  int     status;
public:
  Buffer(unsigned int =DEFAULT_BUFFER_SIZE);
  ~Buffer();
  void RemUse();
  //unsigned int Read(void*,unsigned int,unsigned int);
  //unsigned int Write(void*,unsigned int,unsigned int);
  int   Status();
  void  FreeBuffer();
  void  MarkBuffer();
  void* BufferAddress();
};


#define DEFAULT_BUFFER_POOL_MAX_LENGTH  512    

class BufferPool
{
private:
  int            length;
  int            buffer_size;
  List<Buffer>   list;
  List<Buffer>   free_list;
  void MakeFreeList();
public:
  BufferPool(int = DEFAULT_BUFFER_POOL_MAX_LENGTH,int = DEFAULT_BUFFER_SIZE);
  ~BufferPool();
  Buffer* QueryBuffer();
  unsigned int QueryBufferVector(Buffer**,unsigned int);
  void ReleaseBufferVector(Buffer**,unsigned int);
  unsigned int BuffersSize();
};

#endif
